"use strict";
var internal_1 = require("./internal");
var ExpressAdapter_1 = require("./ExpressAdapter");
var Bootstrapper = (function () {
    function Bootstrapper(app, services) {
        this.app = app;
        this.controllers = [];
        this.adapter = new ExpressAdapter_1.default(app, services);
    }
    Bootstrapper.middleware = function (generateMiddleware) {
        return function () {
            var values = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                values[_i - 0] = arguments[_i];
            }
            return function (targetClass, methodName, descriptor) {
                var middleware = generateMiddleware(values);
                internal_1.addRouteMiddleware(targetClass, methodName, middleware);
                return descriptor;
            };
        };
    };
    Bootstrapper.prototype.controller = function (controllerClass) {
        this.controllers.push(controllerClass);
        internal_1.applyConfiguration(this.adapter, controllerClass);
        return this;
    };
    return Bootstrapper;
}());
exports.Bootstrapper = Bootstrapper;
//# sourceMappingURL=Bootstrapper.js.map